step_medianimpute {recipes} | R Documentation

## Impute Numeric Data Using the Median

### Description

`step_medianimpute` creates a specification of a recipe step that will substitute missing values of numeric variables by the training set median of those variables.

### Usage

    step_medianimpute(recipe, ..., role = NA, trained = FALSE,
      medians = NULL, skip = FALSE, id = rand_id("medianimpute"))

    ## S3 method for class 'step_medianimpute'
    tidy(x, ...)

### Arguments

`recipe` | A recipe object. The step will be added to the sequence of operations for this recipe.
`...` | One or more selector functions to choose which variables are affected by the step. See `selections()` for more details. For the `tidy` method, these are not currently used.
`role` | Not used by this step since no new variables are created.
`trained` | A logical to indicate if the quantities for preprocessing have been estimated.
`medians` | A named numeric vector of medians. This is `NULL` until computed by `prep.recipe()`.
`skip` | A logical. Should the step be skipped when the recipe is baked by `bake.recipe()`? While all operations are baked when `prep.recipe()` is run, some operations may not be able to be conducted on new data (e.g. processing the outcome variable(s)). Care should be taken when using `skip = TRUE` as it may affect the computations for subsequent operations
`id` | A character string that is unique to this step to identify it.
`x` | A `step_medianimpute` object.

### Details

`step_medianimpute` estimates the variable medians from the data used in the `training` argument of `prep.recipe`. `bake.recipe` then applies the new values to new data sets using these medians

### Value

An updated version of `recipe` with the new step added to the sequence of existing steps (if any). For the `tidy` method, a tibble with columns `terms` (the selectors or variables selected) and `model` (the median value).

### Examples

    data("credit_data")

    ## missing data per column
    vapply(credit_data, function(x) mean(is.na(x)), c(num = 0))

    set.seed(342)
    in_training <- sample(1:nrow(credit_data), 2000)

    credit_tr <- credit_data[ in_training, ]
    credit_te <- credit_data[-in_training, ]
    missing_examples <- c(14, 394, 565)

    rec <- recipe(Price ~ ., data = credit_tr)

    impute_rec <- rec %>%
      step_medianimpute(Income, Assets, Debt)

    imp_models <- prep(impute_rec, training = credit_tr)

    imputed_te <- bake(imp_models, new_data = credit_te, everything())

    credit_te[missing_examples,]
    imputed_te[missing_examples, names(credit_te)]

    tidy(impute_rec, number = 1)
    tidy(imp_models, number = 1)

[Package recipes version 0.1.5 Index]